/* Program um.cc        */
/* By Harald Stauss     */
/* Last change 10.08.00 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <iostream.h>
#include <fstream.h>

main(int argc, char *argv[])
{
  ifstream indat;
  ofstream hrout, bpout;
  char     *linie, *clinie, h1[10], h2[10];
  char     **t1, **t2, **hr, **bp;
  int      i, offset, pos;

  /* H e l l o   w o r l d */
  cout << "um Ver.1.0 by H. Stauss, 2000 \n";

  /* A r r a y s   a l l o c i e r e n */
  linie=new char[1001];
  t1=new (char *) [100];
  t2=new (char *) [100];
  hr=new (char *) [100];
  bp=new (char *) [100];

  for (i=0; i<100; i++) {
    t1[i]=new char [80];
    t1[i][0]='\0';
    t2[i]=new char [80];
    t2[i][0]='\0';
    hr[i]=new char [80];
    hr[i][0]='\0';
    bp[i]=new char [80];
    bp[i][0]='\0';
  }

  /* P a r a m e t e r   e i n l e s e n */
  if (argc != 2) {
    printf("Number of parameters wrong! \n");
    printf("um fin \n");
    printf("Sortiert Werte der 24h Messungen \n");
    printf("Benoetigt die Ausgabedatei von zerleg \n");
    printf("haengt 24 Stundenwerte an Dateien hr.dat und bp.dat an (append) \n");
    printf("fin: name of input file  \n");
    goto ende;
  }
  
  /* E i n g a b e d a t e i e n   o e f f n e n */
  indat.open(argv[1]);
  if (!indat) {
    printf("Can't open file %s \n",argv[1]);
    goto ende;
  }

  /* Ausgabedateien oeffnen */
  hrout.open("hr.dat",ios::app,0);
  if (!hrout) {
    printf("Can't open file hr.dat \n");
    goto ende;
  }
  bpout.open("bp.dat",ios::app,0);
  if (!bpout) {
    printf("Can't open file bp.dat \n");
    goto ende;
  }

  printf("Input file   : %s \n", argv[1]);
  printf("Output file  : %s \n", "24h.dat");
  
  /* M A I N L O O P  */
  /* Werte einlesen */
  for (i=0; i<5; i++) indat.getline(linie,1000); /* header berspringen */
  for (i=0; i<48; i++) {
    if (!indat.eof()) {
      indat.getline(linie,1000);
      clinie=strtok(linie," \t");
      if (clinie) {
	/* get offset */
	if (i==0) {
	  strcpy(h1,clinie);
	  strcpy(h2,clinie);
	  h1[2]='\0'; h2[5]='\0';
	  offset=2*atoi(h1)+atoi(h2+3)/30;
	  cout << "offset: " << offset << "\t" << h1 << "\t" << h2+3 << "\n";;
	}
	if (i+offset<48) pos=i+offset;
	else pos=i+offset-48;
	strcpy(t1[pos],clinie);
	clinie=strtok(NULL," \t");
	strcpy(t2[pos],clinie);
	clinie=strtok(NULL," \t");
	strcpy(hr[pos],clinie);
	clinie=strtok(NULL," \t");
	strcpy(bp[pos],clinie);
      }
    }
  }
  for (i=0; i<48; i++) {
    if (strlen(t1[i])==0) {
      strcpy(t1[i], "-");
      strcpy(t2[i], "-");
      strcpy(hr[i], "-");
      strcpy(bp[i], "-");
    }
    cout << i << ": " << t1[i] << "\t" << t2[i] << "\t" << hr[i] << "\t" << bp[i] << "\n";
  }
  /* Ausgabedatei schreiben */
  hrout << argv[1];
  bpout << argv[1];
  for (i=0; i<48; i++) {
    hrout << "\t" << hr[i];
    bpout << "\t" << bp[i];
  }
  hrout << "\n";
  bpout << "\n";

  /* ende */
 ende:
  indat.close(); hrout.close(); bpout.close();
  delete [] t1; delete [] t2; delete [] hr; delete [] bp;
  return(0);
} /* Ende von main */
